=== debian/changelog ===
lammps (0~20181211.gitad1b1897d+dfsg1-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Anton Gladky <gladk@debian.org>  Mon, 24 Dec 2018 19:47:44 +0100

lammps (0~20181211.gitad1b1897d+dfsg1-1) unstable; urgency=medium

  * [63546ae] Fix typo in d/copyright
  * [863405f] Update install-file
  * [b47a528] Update patches
  * [7466010] New upstream version 0~20181211.gitad1b1897d+dfsg1

 -- Anton Gladky <gladk@debian.org>  Thu, 20 Dec 2018 21:27:37 +0100

lammps (0~20180822.gitb47e49223+dfsg1-2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.
  * [5a0371f] Disable voronoi tesselation
  * [fee8ee3] Remove dependenvy on libsymspg-dev

 -- Anton Gladky <gladk@debian.org>  Sun, 16 Sep 2018 09:31:35 +0200
