## lammps 20190919+dfsg2

=== debian/changelog ===
lammps (20190919+dfsg2-2) unstable; urgency=medium

  * Team upload.
  * mark liblammps0 as Multi-Arch: same

 -- Drew Parsons <dparsons@debian.org>  Mon, 30 Dec 2019 10:35:45 +1100

lammps (20190919+dfsg2-1) unstable; urgency=medium

  * Team upload.
  * New upstream patch release 19 Sep 2019. Closes: #925729.
  * move Files-Excluded to Source stanza of debian/copyright.
    Enables mk-origtargz to removed unwanted files in upstream tarball
    - drop examples/log.* (no longer present in upstream tarball)
    - do not exclude doc/utils/sphinx-config from orig tarball.
      Needed to build docs with `make html`.
      sphinx-config/_themes/lammps_theme uses MIT licence.
  * Standards-Version: 4.4.1
  * debhelper compatibility level 12: debhelper-compat (= 12)
  * Build-Depends: python3-all-dev. Closes: #936814.
  * Build-Depends: libvtk7-dev, libhdf5-mpi-dev
  * Build-Depends: libvtk7-qt-dev. Causes USER-VTK to build against
    Qt5 (via vtkGUISupportQt).
  * Debian patch build_docs_direct.patch eliminates virtualenv,
    enabling `make html` to build docs directly. Uses python3 only.
  * provide shared library in liblammps-dev, liblammps0
  * provide python module in python3-lammps (with examples)
    - Debian patch python_lib_soname.patch points the LAMMPS library
      used in lammps.py at soversion .so.0 instead of .so.
      Allows the python module to depend only on liblammps0, otherwise
      liblammps-dev would also have to be installed.
  * provide sample scripts and benchmarks in lammps-examples
    - install in /usr/share/lammps to link to potentials.
      Closes: #924189.
  * emacs mode installed by lammps-data
  * mark -doc, -data, -examples as Multi-Arch: foreign
  * disable dh_dwz on liblammps.so.0 (elf_update failed)
  * Debian patch fix_man.patch fixes section and space delimiter in
    lammps.1.

 -- Drew Parsons <dparsons@debian.org>  Thu, 31 Oct 2019 21:51:12 +0800

lammps (0~20181211.gitad1b1897d+dfsg1-2) unstable; urgency=medium

  * Team upload.
  * Build-Depends: gfortran
    Closes: #923466

 -- Andreas Tille <tille@debian.org>  Fri, 08 Mar 2019 07:18:57 +0100
