=== debian/control ===
--- 
+++ 
@@ -3,32 +3,44 @@
 Uploaders: Anton Gladky <gladk@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 12),
                libeigen3-dev,
                cmake,
-               fortran-compiler,
+               dh-python,
+               gfortran | fortran-compiler,
                libfftw3-dev,
                libjpeg-dev,
                mpi-default-bin,
                mpi-default-dev,
-               libpython-dev,
+               python3-all-dev,
+               libsymspg-dev,
                libavcodec-dev,
                libnetcdf-dev,
-               libvtk6-dev,
-               ocl-icd-opencl-dev
-Build-Depends-Indep: texlive-latex-recommended,
-                     htmldoc
-Standards-Version: 4.2.1
+               libhdf5-mpi-dev,
+               libvtk7-dev, libvtk7-qt-dev,
+               ocl-icd-opencl-dev | opencl-dev,
+               python3-sphinx,
+               voro++-dev
+Build-Depends-Indep: libjs-jquery,
+                     libjs-underscore,
+                     texlive-latex-recommended,
+                     texlive-fonts-recommended,
+                     texlive-latex-extra,
+                     htmldoc,
+                     python3-sphinxcontrib.spelling,
+Standards-Version: 4.4.1
 Vcs-Browser: https://salsa.debian.org/science-team/lammps
 Vcs-Git: https://salsa.debian.org/science-team/lammps.git
 Homepage: http://lammps.sandia.gov/
 
 Package: lammps
 Architecture: any
-Depends: ${misc:Depends},
+Depends: lammps-data,
+         ${misc:Depends},
          ${shlibs:Depends},
-         mpi-default-bin
+         mpi-default-bin,
 Recommends: lammps-doc
+Suggests: python3
 Description: Molecular Dynamics Simulator
  LAMMPS is a classical molecular dynamics code, and an acronym for Large-scale
  Atomic/Molecular Massively Parallel Simulator.
@@ -42,14 +54,14 @@
  techniques and a spatial-decomposition of the simulation domain. The code is
  designed to be easy to modify or extend with new functionality.
 
-Package: lammps-doc
-Architecture: all
-Section: doc
-Depends: ${misc:Depends},
-         libjs-mathjax,
-         libjs-jquery,
-         libjs-underscore
-Description: Molecular Dynamics Simulator. Documentation and examples
+Package: liblammps-dev
+Architecture: any
+Depends: liblammps0 (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends},
+         mpi-default-dev
+Recommends: lammps-doc
+Description: Molecular Dynamics Simulator (dev files)
  LAMMPS is a classical molecular dynamics code, and an acronym for Large-scale
  Atomic/Molecular Massively Parallel Simulator.
  .
@@ -62,10 +74,81 @@
  techniques and a spatial-decomposition of the simulation domain. The code is
  designed to be easy to modify or extend with new functionality.
  .
- The package contains documentation and examples.
+ This package contains development files and headers to build applications
+ using the LAMMPS shared library.
+
+Package: liblammps0
+Architecture: any
+Multi-Arch: same
+Depends: ${misc:Depends},
+         ${shlibs:Depends},
+Description: Molecular Dynamics Simulator (shared library)
+ LAMMPS is a classical molecular dynamics code, and an acronym for Large-scale
+ Atomic/Molecular Massively Parallel Simulator.
+ .
+ LAMMPS has potentials for soft materials (biomolecules, polymers) and
+ solid-state materials (metals, semiconductors) and coarse-grained or
+ mesoscopic systems. It can be used to model atoms or, more generically, as a
+ parallel particle simulator at the atomic, meso, or continuum scale.
+ .
+ LAMMPS runs on single processors or in parallel using message-passing
+ techniques and a spatial-decomposition of the simulation domain. The code is
+ designed to be easy to modify or extend with new functionality.
+ .
+ This package provides the LAMMPS shared library.
+
+Package: python3-lammps
+Architecture: any
+Depends: liblammps0,
+         ${misc:Depends},
+         ${python3:Depends},
+         ${shlibs:Depends},
+         mpi-default-bin,
+Recommends: python3-mpi4py, lammps-doc
+Section: python
+Description: Molecular Dynamics Simulator
+ LAMMPS is a classical molecular dynamics code, and an acronym for Large-scale
+ Atomic/Molecular Massively Parallel Simulator.
+ .
+ LAMMPS has potentials for soft materials (biomolecules, polymers) and
+ solid-state materials (metals, semiconductors) and coarse-grained or
+ mesoscopic systems. It can be used to model atoms or, more generically, as a
+ parallel particle simulator at the atomic, meso, or continuum scale.
+ .
+ LAMMPS runs on single processors or in parallel using message-passing
+ techniques and a spatial-decomposition of the simulation domain. The code is
+ designed to be easy to modify or extend with new functionality.
+ .
+ This package provides the Python module for LAMMPS.
+
+Package: lammps-doc
+Architecture: all
+Multi-Arch: foreign
+Section: doc
+Depends: ${misc:Depends},
+         ${sphinxdoc:Depends},
+         libjs-mathjax,
+         libjs-jquery,
+         libjs-underscore
+Recommends: lammps-examples
+Description: Molecular Dynamics Simulator (documentation)
+ LAMMPS is a classical molecular dynamics code, and an acronym for Large-scale
+ Atomic/Molecular Massively Parallel Simulator.
+ .
+ LAMMPS has potentials for soft materials (biomolecules, polymers) and
+ solid-state materials (metals, semiconductors) and coarse-grained or
+ mesoscopic systems. It can be used to model atoms or, more generically, as a
+ parallel particle simulator at the atomic, meso, or continuum scale.
+ .
+ LAMMPS runs on single processors or in parallel using message-passing
+ techniques and a spatial-decomposition of the simulation domain. The code is
+ designed to be easy to modify or extend with new functionality.
+ .
+ The package contains documentation.
 
 Package: lammps-data
 Architecture: all
+Multi-Arch: foreign
 Section: doc
 Depends: ${misc:Depends}
 Description: Molecular Dynamics Simulator. Data (potentials)
@@ -82,3 +165,24 @@
  designed to be easy to modify or extend with new functionality.
  .
  The package contains data (potentials)
+
+Package: lammps-examples
+Architecture: all
+Multi-Arch: foreign
+Section: doc
+Depends: ${misc:Depends}
+Recommends: lammps
+Description: Molecular Dynamics Simulator (examples)
+ LAMMPS is a classical molecular dynamics code, and an acronym for Large-scale
+ Atomic/Molecular Massively Parallel Simulator.
+ .
+ LAMMPS has potentials for soft materials (biomolecules, polymers) and
+ solid-state materials (metals, semiconductors) and coarse-grained or
+ mesoscopic systems. It can be used to model atoms or, more generically, as a
+ parallel particle simulator at the atomic, meso, or continuum scale.
+ .
+ LAMMPS runs on single processors or in parallel using message-passing
+ techniques and a spatial-decomposition of the simulation domain. The code is
+ designed to be easy to modify or extend with new functionality.
+ .
+ The package contains example scripts and benchmarks.
